%note = ( # ̾Ȳֹб
    '', 27, '', 29, '', 31, 'ե', 32,
    '', 34, '', 36, '', 38, '', -1,
);

$notepat = join('|',keys(%note));
$level = 0;         # ͥȥ٥
$env[$level] = 's'; # par / ser
$channel = 1;
$unitlen = 100;

sub unitlen{    # ñ̻֤
	$unitlen = $_[0];
}
sub transpose{    # ñ̻֤
	$transpose = $_[0];
}
sub inst {
	local($ch,$inst) = @_;
	&add(sprintf("0 0 C e0%02x",
		($ch << 6) + ($inst & 0x3f)),0);
	&add(sprintf("0 0 C e1%02x",
		($ch << 6) + 0x02 + (($inst & 0x40)>>6)),0);
}
sub version { $versiondata = $_[0]; }
sub date { $datedata = $_[0]; }
sub copyright { $copydata = $_[0]; }
sub title { $titledata = $_[0]; }
sub channel { $channel = $_[0]; }
sub parbegin { &begin('p'); }
sub serbegin { &begin('s'); }
sub begin {
	$level++;
	$env[$level] = $_[0];
	$out[$level] = '';
	$len[$level] = 0;
}
sub serend { &parend; }
sub parend {
	$level--;
	&add($out[$level+1],$len[$level+1]);
}
sub add { # ¸ǡ˿ǡɲ
	local($buf,$len) = @_;
	if($env[$level] eq 's'){ # ǡϢ
		$out[$level] .= &timeshift($buf,$len[$level]);
		$len[$level] += $len;
	}
	else { # ǡޡ
		$out[$level] = &timesort($out[$level].$buf);
		$len[$level] = ($len[$level] > $len ?
				$len[$level] : $len );
	}
}
sub play {
	local($_) = @_;
	local($t,$buf,$note,$notename,$ts);
	$ts = $t = 0;
	while($_ ne ''){
		if(s/^_//){ $offset[$channel] -= 12; next; }
		if(s/^\^//){ $offset[$channel] += 12; next; }
		if(s/^//){ $t += $unitlen; next; }
		if(s/^($notepat)([#b]?)//){
			$notename = $1;
			$sharpflat = $2;
			if($t > 0 && $note > 0){
				$buf .= sprintf("$ts $t $channel $prevnote\n");
			}
			$note = $note{$notename};
			$note += ($sharpflat eq '#' ? 1 :
				  $sharpflat eq 'b' ? -1 : 0);
			$note += $transpose;
		$ts = $t;
		$prevnote = $note+$offset[$channel];
		}
		elsif(s/^([\x80-\xff])(.)//){ } # ɥ߰ʳδ
		else { s/^.//; }
		$t += $unitlen;
	}
	if($t > 0 && $note > 0){
		$buf .= sprintf("$ts $t $channel $prevnote\n");
	}
	&add($buf,$t);
}
sub bytime {
	local($ta,$tb);
	$a =~ /^(\d+)\s/;
	$ta = $1;
	$b =~ /^(\d+)\s/;
	$tb = $1;
	$ta <=> $tb;
}
sub timesort { # ٥Ȥ˥
	local($s) = @_;
	local(@a);
	@a = split(/\n/,$s);
	@a = sort bytime @a;
	join("\n",@a) . "\n";
}
sub timeshift { # ٥ȯ򥷥ե
	local($s,$t) = @_;
	local(@a,$i,$s1,$s2);
	@a = split(/\n/,$s);
	for($i=0;$i<=$#a;$i++){
		$a[$i] =~ /^(\d+)\s+(\d+)\s+(.*)$/;
		$s1 = $1; $s2 = $2; $s3 = $3;
		$a[$i] = ($s1+$t) . ' ' .  ($s2+$t) . " $s3";
	}
	join("\n",@a) . "\n";
}
sub prologue { }
sub epilogue {
	@out = split(/\n/,$out[0]);
	$s = '';
	$prevt = 0; 
	for (@out){
		($ts,$te,$ch,$note) = split;
		$dt = $ts - $prevt;
		$prevt = $ts;
		if($ch eq 'C'){
			$s .= sprintf("<0x%02x> <0xff> <<0x%s>>\n",$dt,$note); 
		}
		else {
			$s .= sprintf("<0x%02x> <0x%02x> <0x%02x>\n",$dt,
				(($ch << 6) + $note),$te-$ts);
		}
	}
	$trackdata = $s;
	$trackdatalen = &len($trackdata);
	$trackheader = "{trac} <<<$trackdatalen>>>\n";
	$trackblock = $trackheader . $trackdata;

	if($versiondata){
		$versiondatalen = length($versiondata);
		$versionblock = "{vers} <<$versiondatalen>> {$versiondata}\n";
	}
	if($datedata){
		$datedatalen = length($datedata);
		$dateblock = "{date} <<$datedatalen>> {$datedata}\n";
	}
	if($copydata){
		$copydatalen = length($copydata);
		$copyblock = "{copy} <<$copydatalen>> {$copydata}\n";
	}
	if($titledata){
		$titledatalen = length($titledata);
		$titleblock = "{titl} <<$titledatalen>> {$titledata}\n";
	}

	$padding = "<0x01> <0x01> <0x01>\n";
	$prefix = $padding . $versionblock . $dateblock .
		$copyblock . $titleblock;
	$prefixlen = &len($prefix);
	$headerblock = "<<$prefixlen>> $prefix";

	$melodydata = $headerblock . $trackblock;
	$melodydatalen = &len($melodydata);
	$melody = "{melo} <<<$melodydatalen>>>\n" . $melodydata;

	print $melody;
}

sub len {
	local($_) = @_;
	local($len) = 0;
	while($_ ne ''){
		if(s/^<<<[^>]+>>>//){ $len+=4; }
		elsif(s/^<<[^>]+>>//){ $len+=2; }
		elsif(s/^<[^>]+>//){ $len++; }
		elsif(s/^\{(.[^\}]*)\}//){ $len += length($1); }
		else { s/^[\x00-\xff]//; }
	}
	$len;
}
1;
